C===============================COMP.FOR================================
C     
C       COMP:   COMPILES STRING OF UNITS TO ITS FUNDAMENTAL CONVERSION 
C               FACTOR AND PRODUCES AN EIGHT ELEMENT VECTOR OF FUNDA-
C               MANTAL UNIT POWERS.
C
C       CF:     FINAL COVERSION FACTOR IN TERMS OF FUNDAMENTAL UNITS.
C       VPOW:   8 ELEMENT VECTOR;
C                       1 = Kilogram
C                       2 = Meter
C                       3 = Second
C                       4 = Ampere
C                       5 = Candela
C                       6 = Kelvin
C                       7 = Null (Dimensionless)
C                       8 = Mol
C       STRU:   STRING OF UNITS
C       TV:     TABLE OF VALUES (FUNDAMENTAL CONVERSION FACTORS)
C       TU:     TABLE OF FUNDAMENTAL UNIT NAMES 
C       TFUP:   TABLE OF FUNDAMENTAL UNIT POWERS
 
      SUBROUTINE COMP(CF, VPOW, STRU, TV, TU, TUIND, TFUP)
      PARAMETER (MAXUNIT=7, MAXARG=70)
      REAL*8 CF, F, TV(120)
      INTEGER VPOW(8), VP(8), TFUP(120,8), SIGN, IND, POWER, SH
      INTEGER TUIND(120)
      CHARACTER*(MAXARG) STRU
      CHARACTER*423 TU
      CHARACTER*(MAXUNIT) UNIT
      SIGN=1
      CF=1D0
      DO 100, K=1,8
      VPOW(K)=0
 100  CONTINUE         
 5    IF (SIGN .EQ.  0) GOTO 30
      IF (SIGN .EQ. 99) GOTO 20
      CALL GETUNIT(STRU, UNIT, POWER, SIGN, SH)
      CALL GETCF(F, IND, TU, TUIND, TV, UNIT, POWER, SH)
      CALL GETFU(VP, IND, POWER, TFUP)
      CALL VADD(VPOW,VP)
      CF=CF*F
      GOTO 5
 20   PRINT *,'FINISHED WITH 99'
 30   RETURN
      END     

C===========================CF.FOR (main)===============================

c  This program converts from one set of units to another.  Conversion 
c  factors and unit abreviations are defined according to the listing 
c  given in the "...UNITS"  section of the HP-28S reference manual. 
c  
c  CASE IS SIGNIFICANT when entering units.
c
c  The degrees symbol, "ø" is produced by holding down Alt and typing 
c  248 on the numeric key pad.
c  The prefix micro is represented by lowercase u.    /DEE 1-89


      PARAMETER (MAXUNIT=5, MAXARG=70)
      REAL*8 TV(120), SUCF, EUCF, CF
      INTEGER  TFUP(120,8), SUPOW(8), EUPOW(8), TUIND(120)
      CHARACTER*423 TU
      CHARACTER*(MAXARG) SU,EU
      CHARACTER*(MAXUNIT) U
C==================MAIN PROGRAM
      CALL TVAL   (TV)
      CALL TUNIT  (TU,TUIND)
      CALL TFUPOW (TFUP)
      
C------------Get Starting and Ending unit conversion arguments-----------
      CALL GETC('Enter the original starting units:',SU)
      CALL GETC('Enter the units to convert to:',EU)
C------------Compiling unit strings to a conversion factor and an 
c            integer unit vector...
      CALL COMP(SUCF, SUPOW, SU, TV, TU, TUIND, TFUP)
      CALL COMP(EUCF, EUPOW, EU, TV, TU, TUIND, TFUP)
C------------Check for consistancy of units...      
      DO 10, K=1, 8
      IF ((SUPOW(K)-EUPOW(K)) .NE. 0) GOTO 20
 10   CONTINUE
      CF=SUCF/EUCF
      PRINT *, 'The conversion factor is: ',CF
      GOTO 30
 20   PRINT *, 'Hey stupid the units do not check!'
 30   END 

c==============================GETFU.FOR================================
c  
C   GETFU:      GIVEN IND THE FUNDAMENTAL UNIT POWERS ARE RETRIEVED FROM 
C               TFU.
C   VP:         RESULT
C   TFUP:       TABLE OF FUND. POWERS                          /DEE 1-89
                                     
      SUBROUTINE GETFU(VP, IND, POWER, TFUP)
      INTEGER VP(8), IND, TFUP(120,8), POWER

      DO 10, J=1,8
      VP(J)=TFUP(IND,J)*POWER
 10   CONTINUE
      RETURN
      END

C===========================GETC.FOR====================================
c
c  Prompted char strings up 80 chars long are retrieved from the screen.
c  /DEE 1-89
      SUBROUTINE GETC(PROMPT,VAL)
      CHARACTER*(*) PROMPT, VAL
 10   FORMAT(A80)
      PRINT *, PROMPT
      READ(*,'(A)') VAL
      PRINT '(1X)'
      RETURN
      END

c==============================CTOI.FOR=================================
c  Converts a character string of numbers into an integer.   /DEE 1-89
c      
      SUBROUTINE CTOI(C,INT,N)
      CHARACTER*(*) C
      INTEGER SIGN, INT, N
      INT = 0
      SIGN = 1
      DO 10 J=1, N
      IF (C(J:J) .EQ. '-') THEN
         SIGN = -1
      ELSE
        NUM = ICHAR(C(J:J))-48
        INT = INT+NUM*10**(N-J)
      ENDIF
 10   CONTINUE
      INT = SIGN * INT
      RETURN
      END         

c===============================GETUNIT.FOR=============================
c
C---GETS FIRST UNIT IN ARG WITH POWER.  REPLACES CORRESPONDING 
C   ELEMENTS IN ARG WITH BLANKS.
C       ARG:    STING OF UNITS
C       U:      A SINGLE CHARACTER UNIT
C       POW:    THE POWER ASSOCIATED WITH THE UNIT
C       SIGN:   THE SIGN OF THIS UNIT TO GET.  MUST GIVEN AS INPUT.
C       J:      THE LENGTH OF THE UNIT.                /DEE 1-89
c      
      SUBROUTINE GETUNIT(ARG,U,POW,SIGN,J)
      PARAMETER (MAXPOW=5, MAXUNIT=7, MAXARG=70)
      CHARACTER*(*) ARG
      CHARACTER*(*) U
      INTEGER POW, SIGN
      CHARACTER*(MAXPOW) SPOW
      I=1
      J=1
      POW=1
      NSIGN = 0
 10   IF (I .GT. MAXARG)          GOTO 16
      IF (ARG(I:I) .EQ. ' ')      GOTO 15
      IF (ARG(I:I) .EQ. '*')      GOTO 11
      IF (ARG(I:I) .EQ. '/')      GOTO 12
      IF (ARG(I:I) .EQ. '^')      GOTO 13
c
      U(J:J) = ARG(I:I)
      ARG(I:I) = ' '
      J=J+1
      GOTO 15
c
 11   NSIGN=1
      ARG(I:I)=' '
      GOTO 16
 12   NSIGN = -1
      ARG(I:I)= ' '
      GOTO 16
 13   K=1
 131  ARG(I:I)=' '
      I=I+1
      IF (I .GT. MAXARG) GOTO 132
      IF (ARG(I:I) .EQ. ' ')      GOTO 131
      IF ((ARG(I:I) .EQ. '*') .OR. (ARG(I:I) .EQ. '/'))  GOTO 132
      SPOW(K:K) = ARG(I:I)
      K=K+1
      GOTO 131
 132  CALL CTOI(SPOW, POW, K-1)
      GOTO 10
 15   I=I+1
      GOTO 10
 16   POW=POW*SIGN
      SIGN=SIGN*NSIGN
      IF (J .EQ. 1) SIGN = 99
      J=J-1
      RETURN
      END       

c==============================GETCF.FOR================================
c
c    Gets the cf from the corresponding indices of TU to TV.
c    Also if forced, it will check for a prefix.  The subroutine 
c    performs the same as the HP-28S in this regard.     /DEE 1-89

      SUBROUTINE GETCF(CF,TIND,TU,TUIND,TV,UNIT,POWER,SH)
      PARAMETER (MAXUNIT=7)
      CHARACTER*423 TU
      CHARACTER*(MAXUNIT) UNIT
      CHARACTER*(MAXUNIT+2) TUNIT
      INTEGER TIND, POWER, SH, PFIXV(16), TUIND(120)
      REAL*8 CF, TV(120)
      CHARACTER*(16) PFIX

      PFIX='EPTGMKHDdcmunpfa'
      DATA PFIXV /18,15,12,9,6,3,2,1,-1,-2,-3,-6,-9,-12,-15,-18/
      CF=1D0

      TUNIT='/' // UNIT 
      TUNIT(SH+2:SH+2)='/'
      TIND=INDEX(TU, TUNIT(1:SH+2))
      IF (TIND .EQ. 0) THEN
         TIND=INDEX(PFIX, UNIT(1:1))
         IF (TIND .EQ. 0) THEN
            PRINT *,'1. Unit and possible prefix unrecognized: ',
     +               UNIT(1:SH)
            STOP
         ENDIF
         CF=10D0**PFIXV(TIND)
         TUNIT='/'// UNIT(2:SH) 
         TUNIT(SH+1:SH+1)='/'
         TIND=INDEX(TU, TUNIT(1:SH+1))
         IF (TIND .EQ. 0) THEN
            PRINT *,'2. Unrecognized unit: ',UNIT(1:SH)
            STOP
         ENDIF
      ENDIF
      DO 10, K=1,120
        IF (TIND .EQ. TUIND(K)) GOTO 20
 10   CONTINUE
      PRINT *, 'ERROR IN GETCF.FOR'
      STOP
 20   TIND=K
      CF=(CF*TV(TIND))**POWER
      RETURN
      END
